using System;
using System.Collections.Generic;
using System.Text;

namespace BO
{
	public class MyReadOnlyCollection<T> : 
		System.Collections.ObjectModel.Collection<T>
	{
		private bool m_isReadOnly;

		internal void SetReadOnly()
		{
			m_isReadOnly = true;
		}

		protected override void RemoveItem(int index)
		{
			throw new InvalidOperationException("MyReadOnlyCollection is read-only") ;
		}

		protected override void ClearItems()
		{
			throw new InvalidOperationException("MyReadOnlyCollection is read-only");
		}

		protected override void InsertItem(int index, T item)
		{
			if (m_isReadOnly)
			{
				throw new InvalidOperationException("MyReadOnlyCollection is read-only");
			}
			else
			{
				base.InsertItem(index, item);
			}
		}

		protected override void SetItem(int index, T item)
		{
			if (m_isReadOnly)
			{
				throw new InvalidOperationException("MyReadOnlyCollection is read-only");
			}
			else
			{
				base.SetItem(index, item);
			}
		}
	}
}
